<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Overview of the Xsens Magnetic Field Mapper API</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Overview of the Xsens Magnetic Field Mapper API </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="s_introduction"></a>
Introduction</h1>
<p>This document gives an introduction to the Xsens Magnetic Field Mapper API (MFM). It serves as a starting point for software developers interested in assessing the basis of the SDK. Information regarding the design considerations can be found on this page <a class="el" href="p_background.html">Xsens Magnetic Field Mapping API Objectives and Considerations</a>.</p>
<h1><a class="anchor" id="s_setup"></a>
Set-up</h1>
<p>The Xsens Magnetic Field Mapper API is implemented as illustrated in the figure below: </p><div class="doxyimage"> <div class="image">
<img src="application_setup.png" alt="application_setup.png"/>
<div class="caption">
Application development set-up</div></div>
</div><p>The MFM provides an interface to easily perform a magnetic field mapping of an Xsens device. An example of a host application which uses the MFM is Xsens' own Magfield Mapper tool as depicted in the figure. <br />
<br />
 As can be seen, the host application developer can choose to use a COM, C, C# or C++ interface. The C++ interface is not available in compiled form but is provided as part of the SDK as source code that is incorporated in the C header files. This C++ interface code implements a convenience wrapper around the C API. This means that the developer does not have to deal with memory management (i.e. easy object-lifetime management) as the class implementation takes care of this. The C# interface is provided as a generated wrapper around the C API. This means the developer does not have to deal with dll calling routines in C#, but has access to C# like structures.<br />
<br />
 The API comprises of two C-interface libraries that are supplied for MS Windows (32 and 64 bit) and Linux. These are:</p>
<ul>
<li>XsTypes that contains generic types (vectors, matrices, quaternions, etc.) and some basic operations on those types. </li>
<li>Xsens Magnetic Field Mapper API that contains the access to functionality as implemented in Xsens devices.</li>
</ul>
<p>The Xsens Magnetic Field Mapper API library depends on Xsens Device API and XsTypes, while XsTypes is an independent library.</p>
<p>The remainder of this document focuses on the C++ interface of the Xsens Magnetic Field Mapper API only. For using the C, C# or COM interface please refer to the <a class="el" href="p_examples.html">Example Code</a> page <br />
<br />
 </p>
<h2><a class="anchor" id="ss_mainClasses"></a>
Important Classes of the C++ interface</h2>
<p>The following two classes available in the C++ interface are classes that are extensively used by a host application. Knowing what these classes are about will give the developer a starting point for implementing a basic application. <br />
<br />
 </p><ul>
<li><a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a>: The central class of the MFM. It handles the administration of devices. It keeps track of all opened devices. An application creates a single <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> object at startup and will use it to access devices and their data.</li>
</ul>
<ul>
<li><a class="el" href="class_xs_mfm_callback.html" title="Structure that contains callback functions for the Xsens Device API. ">XsMfmCallback</a>: Provides event handling. If the host application needs to receive events from MFM a sub class of <a class="el" href="class_xs_mfm_callback.html" title="Structure that contains callback functions for the Xsens Device API. ">XsMfmCallback</a> is created that overrides the virtual event functions the application needs to handle. An instance of the subclass is registered with the <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> object. More information regarding callback implementation can be found in the <a class="el" href="overview.html#s_concurrency">Concurrency</a> section.</li>
</ul>
<h2><a class="anchor" id="ss_deviceTree"></a>
Device Hierarchy</h2>
<p>An Xsens device connects to the system through a communication port (represented by the "Serial communication driver" box in the figure above). The underlying hardware connection for this communication port may be a serial port or a USB connection. A device that is connected directly to the communication port is called a <em>main</em> <em>device</em>. Some main devices, for example an Awinda Station, can expose a set of child devices. These are devices that connect to the main device and all communication between these child devices and MFM goes through the communication port of the main device. However, current version of the MFM only supports 1 child device per main device.<br />
<br />
 At start up the host application will usually discover the available devices through use of the <a class="el" href="struct_xs_mfm.html#a4c4a0eebb3d06835e94c6522c85e00fa" title="Starts a scan for devices of which the magnetic field can be mapped. ">XsMfm::scanMfmDevices</a> function. This function returns a list of communication ports on which an Xsens device is detected/connected and which can be magnetic field mapped by this SDK. After the scan the returned device list will contain child device-IDs, which ports are directly available. <br />
<br />
 </p>
<h2><a class="anchor" id="ss_programFlow"></a>
Program Flow</h2>
<p>This section describes the typical program flow of an application using the MFM. Refer to the <a class="el" href="p_examples.html">Example Code</a> page for some simple application examples reflecting the flow described here.<br />
<br />
 An application that wants to process data from one or more Xsens device will roughly follow the following steps</p>
<ul>
<li>
<p class="startli">General  </p><ol>
<li>
<p class="startli">Prepare for event based signal handling </p><div class="groupText"> Because some actions, like scanning and processing can take some time, using event based data handling the application is signalled with operation results as soon as it is done. To enable this a callback object must be registered. The application creates an object derived from <a class="el" href="class_xs_mfm_callback.html" title="Structure that contains callback functions for the Xsens Device API. ">XsMfmCallback</a> that overrides the <a class="el" href="group___callbacks.html#ga0c2480993821c645859afec5861f1e3b" title="Called when the magfield mapping has completed. ">XsMfmCallback::onMfmDone</a> or XsMfm::onScanDone function. The object is registered with MFM using the <a class="el" href="struct_xs_mfm.html#aaef1cf99e4c4773e06a8c5c065b8a4fa" title="Add a callback handler to the list. ">XsMfm::addCallbackHandler</a> function. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Open an Mfm log file </p><div class="groupText"> Using <a class="el" href="struct_xs_mfm.html#a3ad65aa03dde059704aa1fa064d389ef" title="Load a file which contains a magnetic field mapping movement. ">XsMfm::loadInputFile</a>, a previously recorded magnetic field mapping is loaded. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Start processing </p><div class="groupText"> Using <a class="el" href="struct_xs_mfm.html#a7e88b47745228ddae7b68d2edad8496f" title="Start the magnetic field mapping. ">XsMfm::startProcessing</a>, the just loaded log file is processed. When processing is done, the onMfmDone callback is called. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Store results to file </p><div class="groupText"> Using <a class="el" href="struct_xs_mfm.html#a705a3ae378d0b5f33793eaac0904c6f1" title="Write the result of the magnetic field mapping to the file. ">XsMfm::writeResultToFile</a>, the magnetic field mapping results can be written to a file. This file will contain a message which can be sent directly to a Motion Tracker in config mode. </div><p class="endli"></p>
</li>
<li>
Clean up MFM <div class="groupText"> The application releases the <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> object created at start up using the <a class="el" href="struct_xs_mfm.html#a34b35a888e1c473733efd83c7c59861f" title="Destruct a XsMfm object and free all memory allocated for it. ">XsMfm::destruct</a> function. </div> </li>
</ol>
<p class="endli"></p>
</li>
<li>
Live situation  <ol>
<li>
<p class="startli">Initialize MFM </p><div class="groupText"> The application starts with the creation of an <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> object using the XsMfm::create function. . </div><p class="endli"></p>
</li>
<li>
<p class="startli">Discover devices </p><div class="groupText"> The application detects devices available to the system using the <a class="el" href="struct_xs_mfm.html#a4c4a0eebb3d06835e94c6522c85e00fa" title="Starts a scan for devices of which the magnetic field can be mapped. ">XsMfm::scanMfmDevices</a> function. When done, the onScanDone callback will return all device-IDs of Xsens devices that are connected and usable. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Start logging data </p><div class="groupText"> The application calls <a class="el" href="struct_xs_mfm.html#af09c3bd635f53152eac40f9827e13643" title="Starts logging data for the magnetic field mapping movement. ">XsMfm::startLogging</a>. The devices are set to measurement mode. The user must now perform the movements as described in the Magnetic Field Mapper pdf documentation. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Stop logging data </p><div class="groupText"> The application calls <a class="el" href="struct_xs_mfm.html#a1036dfbd34046fc1ab6e904f1e0a9ae1" title="Stop logging data for the magnetic field mapping movement. ">XsMfm::stopLogging</a>. The devices are set to config mode. The log file is closed </div><p class="endli"></p>
</li>
<li>
<p class="startli">Continue with general </p><div class="groupText"> Here the magnetic field mapping recording is created and the above general situation is applicable. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Write results to device </p><div class="groupText"> Directly writes the magnetic field mapping results to the attached device. After this the device is directly usable with magnetic field mapped calibration values. </div><p class="endli"></p>
</li>
</ol>
</li>
</ul>
<h2><a class="anchor" id="s_concurrency"></a>
Concurrency</h2>
<p>The Xsens MFM SDK implements a concurrent system. This means that: </p><ul>
<li>The MFM functions are implemented in a thread-safe way. </li>
<li>The MFM framework supports asynchronous events.</li>
</ul>
<p>To make the MFM functions thread-safe, data manipulation is controlled tightly and care is taken that function calls are non-blocking. This last point is also achieved by caching all information that would be required from the device.<br />
<br />
 The asynchronous events are handled by implementing a <em>callback</em> object. This can be achieved through creating a class inherited from <a class="el" href="class_xs_mfm_callback.html" title="Structure that contains callback functions for the Xsens Device API. ">XsMfmCallback</a> that overrides the virtual event functions. The callback object is registered in the <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> object.<br />
<br />
 To illustrate the set-up, see the figure and description given below: </p><div class="doxyimage"> <div class="image">
<img src="callback_example.png" alt="callback_example.png"/>
<div class="caption">
Illustrative example of the callback functionality</div></div>
 </div><p>In this example the application starts the magnetic field mapping of a device using the <a class="el" href="struct_xs_mfm.html#a7e88b47745228ddae7b68d2edad8496f" title="Start the magnetic field mapping. ">XsMfm::startProcessing</a> function. From this point on the magnetic field mapping is performed. When done the worker thread will call the onMfmDone() callback function. This call will end up in the overloaded function of the callback object implemented by the application developer.<br />
<br />
 It is a good practice to take any actions based on callbacks in a separate thread. This can be achieved by using an OS messaging mechanism to forward the event to the application's main event loop. The callback function runs in the context of <a class="el" href="struct_xs_mfm.html" title="High level Magnetic Field Mapper (MFM) management class. ">XsMfm</a> worker thread and problems can occur if MFM functions that change the state of the MFM (such as scanMfmDevices or reset) or the application (such as showing a window) are called from within the callback handler. For example, most GUI-toolkits require that all operations are performed from a single thread.<br />
<br />
</p>
</div></div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Thu Jun 29 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
